Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 2364)
+++ palm/trunk/SCRIPTS/mbuild	(revision 2365)
@@ -27,4 +27,7 @@
 # -----------------
 # $Id$
+# Added lckea & lckeam. KIT/IMK-IFU Garmisch cluster. LRZ (SadiqHuq)
+# 
+# 2316 2017-07-20 07:53:42Z maronga
 # Removed qmake block as mrungui now runs as a python script
 # 
@@ -531,4 +534,5 @@
        # DETERMINE IP-ADDRES OF THE REMOTE-HOST
     case  $remote_host  in
+        (lcbwuni)        remote_address="129.13.82.89";;
         (lcbullhh)       remote_address=136.172.50.13;;
         (lccrayb)        remote_address=130.73.233.1;;
@@ -541,4 +545,6 @@
         (lckiaps)        remote_address=118.128.66.223;;
         (lckyut)         remote_address=133.5.4.37;;
+        (lclrz)          remote_address=129.187.20.240;;
+        (lckea*)         remote_address=172.27.80.109;;
         (lctit)          remote_address=10.1.6.170;;
         (lcxe6)          remote_address=129.177.20.113;;
@@ -547,4 +553,5 @@
         (ibmkisti)       remote_address=150.183.146.24;;
         (ibmku)          remote_address=133.5.4.129;;
+        (ibmmuc)         remote_address=129.187.11.197;;
         (ibms)           remote_address=150.183.5.101;;
         (nech)           remote_address=136.172.44.192;;
@@ -783,5 +790,10 @@
        elif [[ $(echo $remote_host | cut -c1-3) = ibm  &&  $(echo $string | cut -c1-3) = ibm ]]
        then
-          cpp_options="${cpp_options},-D__ibm"
+          if [[ $remote_host = ibmmuc ]]
+          then
+             cpp_options="${cpp_options}"
+          else
+             cpp_options="${cpp_options},-D__ibm"
+          fi
        elif [[ $(echo $remote_host | cut -c1-3) = nec  &&  $(echo $string | cut -c1-3) = nec ]]
        then
@@ -790,5 +802,10 @@
           if [[ $(echo $remote_host | cut -c1-3) = ibm ]]
           then
-             cpp_options="${cpp_options},-D__$string"
+             if [[ $remote_host = ibmmuc ]]
+             then
+                cpp_options="${cpp_options} -D__parallel"
+             else
+                cpp_options="${cpp_options},-D__$string"
+             fi
           else
              cpp_options="$cpp_options -D__$string "
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 2364)
+++ palm/trunk/SCRIPTS/mrun	(revision 2365)
@@ -27,4 +27,8 @@
 # -----------------
 # $Id$
+# Added lckea & lckeam. KIT/IMK-IFU Garmisch cluster. LRZ (SadiqHuq)
+# Vertical grid nesting: set vnested_mode. -N Procs for fine and coarse grid.
+# 
+# 2303 2017-07-04 12:26:18Z raasch
 # bugfix: setting default value for write_binary
 # 
@@ -334,4 +338,6 @@
  module_calls=""
  mrun_script_name=$mc
+ vnested_dist=""
+ vnested_mode="vnested_twi"
  netcdf_inc=""
  netcdf_lib=""
@@ -341,4 +347,6 @@
  numprocs_atmos=0
  numprocs_ocean=0
+ numprocs_crse=0
+ numprocs_fine=0
  OOPT=""
  openmp=false
@@ -373,4 +381,5 @@
  run_coupled_model=false
  run_mode=""
+ run_vnested_model=false
  dashes="  ----------------------------------------------------------------------------"
  silent=false
@@ -475,5 +484,5 @@
     # READ SHELLSCRIPT-OPTIONS AND REBUILD THE MRUN-COMMAND STRING (MC),
     # WHICH WILL BE USED TO START RESTART-JOBS
- while  getopts  :a:bBc:Cd:Fg:G:h:H:i:kK:m:M:n:o:O:p:P:q:r:R:s:St:T:u:U:vw:xX:yY:zZ option
+ while  getopts  :a:bBc:Cd:Fg:G:h:H:i:kK:m:M:n:N:o:O:p:P:q:r:R:s:St:T:u:U:vw:xX:yY:zZ option
  do
    case  $option  in
@@ -495,4 +504,5 @@
        (M)   makefile=$OPTARG; mc="$mc -M$OPTARG";;
        (n)   node_usage=$OPTARG; mc="$mc -n$OPTARG";; 
+       (N)   run_vnested_model=true; vnested_dist=$OPTARG; mc="$mc -N'$OPTARG'";;
        (o)   output_list=$OPTARG; mc="$mc -o'$OPTARG'";;
        (O)   use_openmp=true; threads_per_task=$OPTARG; mc="$mc -O$OPTARG";;
@@ -550,4 +560,6 @@
     printf "\n        -M    Makefile name                            Makefile"
     printf "\n        -n    node usage (shared/not_shared)           depending on -h"
+    printf "\n        -N    Vertical grid nesting. Number of"
+    printf "\n              PE for Coarse and Fine grid"
     printf "\n        -o    OUTPUT control list                      \"\" "
     printf "\n        -O    threads per openMP task                  ---"
@@ -713,4 +725,34 @@
  fi
 
+      # NESTING (-N) selected and vnesting_mode specified
+ if [[ $run_vnested_model = true ]] 
+ then
+
+    if  [[ -n $vnested_dist ]]
+    then
+
+       numprocs_crse=`echo $vnested_dist | cut -d" " -s -f1`
+       numprocs_fine=`echo $vnested_dist | cut -d" " -s -f2`
+
+       if (( $numprocs_crse + $numprocs_fine != $numprocs ))
+       then
+
+          printf "\n  +++ number of processors does not fit to specification by \"-N\"."
+          printf "\n      PEs (total)     : $numprocs"
+          printf "\n      PEs (Coarse)    : $numprocs_crse"
+          printf "\n      PEs (Fine)      : $numprocs_fine"
+          locat=vnesting; exit
+
+       fi
+
+    else
+
+          printf "\n  +++ "Specify PE for fine and coarse grid: -N "nCGPE nFGPE \"-N\"."
+          locat=vnesting; exit
+
+    fi
+    vnested_dist=`echo "$numprocs_crse $numprocs_fine"`
+ fi
+
     # SAVE VALUES OF MRUN-OPTIONS SICHERN IN ORDER TO OVERWRITE
     # THOSE VALUES GIVEN IN THE CONFIGURATION-FILE
@@ -1195,4 +1237,6 @@
         (ibmh)       queue=cluster;;
         (ibmkisti)   queue=class.32plus;;
+        (ibmmuc*)    queue=test;;
+        (lcbwuni)    queue=develop;;
         (lcbullhh)   queue=compute;;
         (lccrayb)    queue=mpp1q;;
@@ -1203,4 +1247,5 @@
         (lckyuh)     queue=fx-single;;
         (lckyut)     queue=cx-single;;
+        (lclrz)      queue=mpp2;;
         (lctit)      queue=S;;
         (unics)      queue=unics;;
@@ -1764,5 +1809,5 @@
 
        # SET PREPROCESSOR-DIRECTIVES TO SELECT OPERATING SYSTEM SPECIFIC CODE
-    if [[ $(echo $localhost | cut -c1-3) = ibm ]]
+    if [[ $(echo $localhost | cut -c1-3) = ibm && $localhost != ibmmuc* ]]
     then
        cpp_options="${cpp_options},-D__ibm=__ibm"
@@ -1778,5 +1823,5 @@
 
        # SET DIRECTIVES GIVEN BY OPTION -K (E.G. parallel)
-    if [[ $(echo $localhost | cut -c1-3) = ibm ]]
+    if [[ $(echo $localhost | cut -c1-3) = ibm && $localhost != ibmmuc ]]
     then
        [[ -n $cond1 ]]  &&  cpp_options="${cpp_options},-D__$cond1=__$cond1"
@@ -1893,6 +1938,11 @@
     fi
  fi
- TEMPDIR=$tmp_user_catalog/${usern}.$kennung
-
+
+if [[ $localhost = ibmmuc* ]]
+then
+   TEMPDIR=$tmp_user_catalog/${USER}.$kennung
+else
+   TEMPDIR=$tmp_user_catalog/${usern}.$kennung
+fi
 
     # DETERMINE THE NAME OF THE DIRECTORY WHICH IS USED TO TEMPORARILY STORE DATA FOR RESTART RUNS
@@ -2792,4 +2842,41 @@
                    then
                       /opt/optibm/HPM_2_4_1/bin/hpmcount  a.out
+                   elif [[  $localhost = ibmmuc* ]]
+                   then
+                      ulimit -c unlimited        # only for debgingg
+                      echo $MP_NODES        > ~/job_queue/hostfile.$kennung
+                      echo $MP_PROCS       >> ~/job_queue/hostfile.$kennung
+                      cat $LOADL_HOSTFILE  >> ~/job_queue/hostfile.$kennung
+                      export MP_NODES=$nodes
+                      export MP_PROCS=$numprocs
+                      # export MPI_SINGLE_THREAD=no   # LRZ NetCDF
+                      # export MP_TASKS_PER_NODE=$tasks_per_node
+                      echo "Resource Info: " 
+                      echo "numprocs:         " $numprocs " MP_PROCS " $MP_PROCS
+                      echo "nodes:            " $nodes    " MP_NODES " $MP_NODES
+                      echo "tasks_per_node:   " $tasks_per_node
+                      echo "threads_per_task: " $threads_per_task
+                      export OMP_NUM_THREADS=1
+                      source /lrz/sys/share/modules/init/bash
+                      module li
+                      echo "runfile_atmos"
+                      
+                      if [[ $run_vnested_model = true ]]
+                      then
+                         
+                         printf "\n      Nested run ($numprocs_crse Coarse, $numprocs_fine Fine)"
+                         printf "\n      using $nested_mode nesting"
+                         printf "\n\n"
+                         
+                         echo "$vnested_mode $numprocs_crse $numprocs_fine"  >  runfile_atmos
+                         
+                         poe   ./a.out  <  runfile_atmos
+                         # mpiexec -n $numprocs  ./a.out  <  runfile_atmos
+                      else
+                         echo "precursor_atmos"  >  runfile_atmos
+                         poe   ./a.out -proc $numprocs -nodes  $nodes <  runfile_atmos  
+                         # mpiexec -n $numprocs  ./a.out  <  runfile_atmos  
+                      
+                      fi
                    else
                       if [[ $run_coupled_model = false ]]
@@ -2899,5 +2986,5 @@
                    printf "\n      threads per task: $threads_per_task  stacksize: unlimited"
                 fi
-                if [[ $run_coupled_model = false ]]
+                if [[ $run_coupled_model = false && $run_vnested_model = false ]]
                 then
                    if [[ "$ocean_file_appendix" = true ]]
@@ -2948,5 +3035,10 @@
                    then
                       mpirun_rsh -hostfile $PBS_NODEFILE -np `cat $PBS_NODEFILE | wc -l` a.out  < runfile_atmos
-
+                   elif [[ $host = lclrz || $host = lcbwuni  ]]
+                   then
+                      mpiexec  -n $ii  a.out  <  runfile_atmos  $ROPTeS
+                   elif [[ $host = lckea* ]]
+                   then
+                      srun  -n $ii  a.out  <  runfile_atmos  $ROPTeS
                    elif [[ $host = lckiaps ]]
                    then
@@ -2959,6 +3051,6 @@
                    fi
 
-                else
-
+                elif [[ $run_coupled_model = true ]]
+                then
                        # COUPLED RUN
                    (( iia = $numprocs_atmos / $threads_per_task ))
@@ -2992,4 +3084,23 @@
                    wait
 
+
+                elif [[ $run_vnested_model = true ]]
+                then
+                    printf "\n      Vertical Nested run ($numprocs_crse Coarse, $numprocs_fine Fine)"
+                    printf "\n      using $vnested_mode vnesting"
+                    printf "\n\n"
+
+                     echo "$vnested_mode $numprocs_crse $numprocs_fine"  >  runfile_atmos
+
+                     if [[  $host = lcbwuni  ||  $host = lclrz*  ]]
+                     then
+                         mpiexec  -n $ii  a.out  <  runfile_atmos  $ROPTeS
+                     elif [[ $host = lckea*  ]]
+                     then
+                         srun  -n $ii  a.out  <  runfile_atmos  $ROPTeS 
+                     else
+                        mpirun   -np $numprocs  ./a.out  $ROPTS  < runfile_atmos
+                     fi
+                     wait
                 fi
 
@@ -3657,4 +3768,5 @@
     [[ "$ocean_file_appendix" = true ]]  &&  mrun_com=${mrun_com}" -y"
     [[ $run_coupled_model = true ]]  &&  mrun_com=${mrun_com}" -Y \"$coupled_dist\""
+    [[ $run_vnested_model  = true ]]  &&  mrun_com=${mrun_com}" -N \"$vnested_dist\""
     [[ "$check_namelist_files" = false ]]  &&  mrun_com=${mrun_com}" -z"
     [[ "$combine_plot_fields" = false ]]  &&  mrun_com=${mrun_com}" -Z"
Index: palm/trunk/SCRIPTS/subjob
===================================================================
--- palm/trunk/SCRIPTS/subjob	(revision 2364)
+++ palm/trunk/SCRIPTS/subjob	(revision 2365)
@@ -28,4 +28,7 @@
 # -----------------
 # $Id$
+# Added lckea & lckeam. KIT/IMK-IFU Garmisch cluster. LRZ (SadiqHuq)
+# 
+# 2295 2017-06-27 14:25:52Z raasch
 # adjustments for using lcgeohu (cirrus @ HUB)
 # 
@@ -252,9 +255,15 @@
      (inferno)               local_address=130.75.105.5;   local_host=lcmuk;;
      (irifi)                 local_address=130.75.105.104; local_host=lcmuk;;
+   # (i*)                    local_address=129.187.11.197; local_host=ibmmuc;;
      (jaboticaba)            local_address=150.163.25.181; local_host=lcbr;;
+     (kea*)                  local_address=172.27.80.109;  local_host=lckeal;;
      (sno)                   local_address=130.75.105.113; local_host=lcmuk;;
      (kuma)                  local_address=130.75.105.115; local_host=lcmuk;;
      (levanto)               local_address=130.75.105.45;  local_host=lcmuk;;
      (login*)                local_address=118.128.66.201; local_host=lckiaps;;
+   # (login*)                local_address=129.187.11.197; local_host=ibmmuc;;
+     (lm*)                   local_address=129.187.11.197; local_host=ibmmuc;;
+     (lx*)                   local_address=129.187.20.240; local_host=lclrz;;
+     (mpp2*)                 local_address=129.187.20.105; local_host=lclrz;;
      (maestro)               local_address=130.75.105.2;   local_host=lcmuk;;
      (meller)                local_address=134.106.74.155; local_host=lcfor;;
@@ -278,4 +287,5 @@
      (tc*)                   local_address="ocean";        local_host=lcocean;; 
      (t2a*)                  local_address=10.1.6.165;     local_host=lctit;;
+     (uc1n*)                 local_address=129.13.82.89;   local_host=lcbwuni;;
      (urban*)                local_address=147.46.30.151   local_host=lcsb;;
      (vinessa)               local_address=130.75.105.112; local_host=lcmuk;;
@@ -409,4 +419,6 @@
         (ibmku)   queue=s4; remote_address=133.5.4.129; submcom=/usr/local/bin/llsubmit;;
         (ibms)    queue=p_normal; remote_address=150.183.5.101; submcom=/usr/lpp/LoadL/full/bin/llsubmit;;
+        (ibmmuc)  remote_address=129.187.11.197; submcom=/usr/bin/llsubmit;;
+        (lcbwuni) queue=develop; remote_address=129.13.82.89; submcom=/opt/moab/bin/msub;;
         (lcbullhh)    queue=compute; remote_address=136.172.50.13; submcom=/usr/bin/sbatch;;
         (lccrayb) queue=mpp1testq; remote_address=130.73.233.1; submcom="/opt/moab/default/bin/msub -E";;
@@ -417,8 +429,10 @@
         (lckyoto) remote_address=133.3.51.11; submcom=/thin/local/bin/qsub;;
         (lck)     remote_address=165.132.26.61; submcom=/usr/torque/bin/qsub;;
+        (lckeal)  queue=ivy; remote_address=172.27.80.109; submcom=/usr/bin/sbatch;;
         (lckiaps) remote_address=118.128.66.201; submcom=/opt/pbs/default/bin/qsub;;
         (lckordi) remote_address=210.219.61.8; submcom=/usr/torque/bin/qsub;;
         (lckyuh)  remote_address=133.5.4.33; submcom=/usr/bin/pjsub;;
         (lckyut)  remote_address=133.5.4.37; submcom=/usr/bin/pjsub;;
+        (lclrz)   remote_address=129.187.20.240; submcom=/usr/bin/sbatch;;
         (lcocean) remote_address="ocean"; submcom=qsub;;
         (lcsb)    remote_address=147.46.30.151; submcom=/usr/torque/bin/qsub;;
@@ -459,8 +473,16 @@
                      (*)                                     error=true;;
                  esac;;
+        (ibmmuc*) case  $ndq  in
+                     (test|micro|general|large|fat|fattest|special|tmp1|tmp2) error=false;;
+                     (*)                                     error=true;;
+                 esac;;
         (lcbullhh) case  $ndq  in
                      (compute|compute2|shared)  error=false;;
                      (*)                                     error=true;;
                  esac;;
+        (lcbwuni) case  $ndq  in
+                     (develop|singlenode|multinode|verylong|fat) error=false;;
+                     (*)                                     error=true;;
+                 esac;;
         (lccrayb) case  $ndq  in
                      (dataq|mpp1q|mpp1testq|mpp2q|mpp2testq|smp1q|smp1testq|specialm1q)   error=false;;
@@ -493,4 +515,8 @@
         (lckyut) case  $ndq  in
                      (cx-dbg|cx-single|cx-small|cx-middle|cx-large)  error=false;;
+                     (*)                                     error=true;;
+                 esac;;
+        (lclrz) case  $ndq  in
+                     (mpp1|mpp2|iuv2|myri)                   error=false;;
                      (*)                                     error=true;;
                  esac;;
@@ -744,5 +770,32 @@
     then
 
-       if [[ $remote_host != ibmkisti ]]
+       if [[ $remote_host == ibmmuc* ]]
+       then
+       cat > $job_to_send << %%END%%
+
+#!/bin/bash
+# @ job_type = parallel
+# @ job_name = $job_name
+# @ output = $remote_dayfile
+# @ error = $remote_dayfile
+# @ wall_clock_limit = $timestring
+$class
+$mcm_affinity_options
+$task_affinity
+$notify_user
+# @ network.MPI = sn_all,not_shared,us
+# @ notification = always
+# @ energy_policy_tag = table_kit_ifu
+# @ minimize_time_to_solution = yes
+# @ node = $nodes
+# @ total_tasks = $numprocs
+# @ node_topology = island
+# @ island_count = 1,2
+# @ environment = LD_LIBRARY_PATH=/lrz/sys/libraries/netcdf/4.2.1.1_impi4/lib:/lrz/sys/libraries/hdf5/1.8.15/ibmmpi/lib:/lrz/sys/libraries/fftw/3.3.3/avx/lib/
+# @ queue
+
+%%END%%
+
+       elif [[ $remote_host != ibmkisti ]]
        then
 
@@ -1248,4 +1301,80 @@
        submcom="$submcom -W group_list=$group_number -N $job_name -l walltime=$timestring -l select=$nodes:ncpus=$processes_per_node:mpiprocs=$tasks_per_node:mem=${Memory}gb -l place=scatter -o $remote_dayfile -j oe -et 1 -q $queue "
     fi
+
+ elif [[ $remote_host = lclrz ]]
+ then
+       cat > $job_to_send << %%END%%
+#!/bin/bash 
+#SBATCH -J $job_name
+#SBATCH -t $timestring
+#SBATCH -N $nodes
+#SBATCH --ntasks-per-node=$processes_per_node
+#SBATCH --get-user-env
+#SBATCH -o $remote_dayfile
+#SBATCH -e $remote_dayfile
+#SBATCH --mail-user=${email_notification}
+#SBATCH --clusters=$queue
+
+$init_cmds
+
+$module_calls
+
+%%END%%
+
+ elif [[ $remote_host = lckea* ]]
+ then
+       keal_tasks_per_core=1
+
+       if [[ $queue = haswell || $queue = ivy* ]]
+       then
+          if (( tasks_per_node > 20 ))
+          then
+             keal_tasks_per_core=2
+	  fi
+       fi
+
+       cat > $job_to_send << %%END%%
+#!/bin/bash 
+#SBATCH -J $job_name
+#SBATCH -t $timestring
+#SBATCH -N $nodes
+#SBATCH --ntasks-per-node=$processes_per_node
+#SBATCH --ntasks-per-core=$keal_tasks_per_core
+#SBATCH --mem-per-cpu=${memory}mb
+#SBATCH --get-user-env
+#SBATCH -o $remote_dayfile
+#SBATCH -e $remote_dayfile
+#SBATCH --mail-user=${email_notification}
+#SBATCH --mail-type=ALL
+#SBATCH --partition=$queue 
+
+export MV2_ENABLE_AFFINITY=0
+
+$init_cmds
+
+$module_calls
+
+%%END%%
+
+ elif [[ $remote_host=lcbwuni ]]
+ then
+    if [[ $email_notification = none ]]
+    then
+       email_directive=""
+    else
+       email_directive="#PBS -M $email_notification"
+    fi
+       cat > $job_to_send << %%END%%
+#!/bin/ksh
+#PBS -N $job_name
+#PBS -l walltime=$timestring
+#PBS -l nodes=${nodes}:ppn=$processes_per_node
+#PBS -l pmem=${memory}mb
+#PBS -m abe
+#PBS -o $remote_dayfile
+#PBS -j oe
+#PBS -q $queue
+$email_directive
+%%END%%
 
  else
@@ -1615,4 +1744,10 @@
              eval  $submcom  $job_on_remhost
           fi
+       elif [[ $local_host = lclrz || $local_host = lckea* ]]
+       then
+          eval  $submcom  $job_on_remhost
+       elif [[ $local_host = lcbwuni ]]
+       then
+          msub  -q $queue $job_on_remhost
        else
           qsub  $job_on_remhost
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 2364)
+++ palm/trunk/SOURCE/Makefile	(revision 2365)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Added dependencies for vertical_nesting_mod
+# 
+# 2339 2017-08-07 13:55:26Z gronemeier
 # corrected timestamp in header
 # 
@@ -409,5 +412,5 @@
 	user_lpm_init.f90 user_lpm_set_attributes.f90 user_module.f90 \
 	user_parin.f90 user_read_restart_data.f90 \
-	user_spectra.f90 user_statistics.f90 virtual_flight_mod.f90 \
+	user_spectra.f90 user_statistics.f90 vertical_nesting_mod.f90 virtual_flight_mod.f90 \
 	wind_turbine_model_mod.f90 write_3d_binary.f90 write_var_list.f90
 
@@ -425,18 +428,4 @@
 # The following line is needed for palm_simple_install, don't remove it!
 #to_be_replaced_by_include
-
-#BOUNDS="-Rbc"  # Array bounds checking. Compromises performance seriously.
-
-F90 = ftn
-#COPT = -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__fftw \
-#             -D__netcdf -D__netcdf4 -D__netcdf4_parallel -D__nopointer
-COPT = -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__fftw \
-             -D__netcdf -D__netcdf4 -D__netcdf4_parallel
-
-#F90FLAGS = -O2 -e Fm -G2 -rm $(BOUNDS) -hnoomp
-F90FLAGS = -O2 -e F -G2 -rm $(BOUNDS) -hnoomp
-LDFLAGS = $(F90FLAGS) -dynamic
-
-# End of include
 
 .SUFFIXES:
@@ -469,5 +458,5 @@
 average_3d_data.o: modules.o cpulog_mod.o mod_kinds.o exchange_horiz_2d.o land_surface_model_mod.o \
 	radiation_model_mod.o urban_surface_mod.o
-boundary_conds.o: modules.o mod_kinds.o pmc_interface_mod.o surface_mod.o
+boundary_conds.o: modules.o mod_kinds.o pmc_interface_mod.o surface_mod.o vertical_nesting_mod.o
 buoyancy.o: modules.o mod_kinds.o
 calc_mean_profile.o: modules.o mod_kinds.o
@@ -480,5 +469,5 @@
 	microphysics_mod.o model_1d_mod.o netcdf_interface_mod.o plant_canopy_model_mod.o pmc_interface_mod.o \
 	radiation_model_mod.o spectra_mod.o subsidence_mod.o synthetic_turbulence_generator_mod.o \
-	wind_turbine_model_mod.o urban_surface_mod.o
+	wind_turbine_model_mod.o urban_surface_mod.o vertical_nesting_mod.o
 close_file.o: modules.o mod_kinds.o netcdf_interface_mod.o
 compute_vpt.o: modules.o mod_kinds.o
@@ -508,5 +497,5 @@
 diffusion_v.o: modules.o mod_kinds.o surface_mod.o
 diffusion_w.o: modules.o mod_kinds.o surface_mod.o
-diffusivities.o: modules.o mod_kinds.o surface_mod.o
+diffusivities.o: modules.o mod_kinds.o surface_mod.o vertical_nesting_mod.o
 disturb_field.o: modules.o cpulog_mod.o mod_kinds.o random_function_mod.o \
                  random_generator_parallel_mod.o
@@ -530,10 +519,11 @@
 init_advec.o: modules.o mod_kinds.o
 init_cloud_physics.o: modules.o mod_kinds.o
-init_coupling.o: modules.o mod_kinds.o
+init_coupling.o: modules.o mod_kinds.o vertical_nesting_mod.o
 init_dvrp.o: modules.o mod_kinds.o
-init_grid.o: modules.o mod_kinds.o advec_ws.o netcdf_interface_mod.o surface_mod.o
+init_grid.o: modules.o mod_kinds.o advec_ws.o netcdf_interface_mod.o surface_mod.o vertical_nesting_mod.o
 init_masks.o: modules.o mod_kinds.o netcdf_interface_mod.o
 init_ocean.o: modules.o eqn_state_seawater.o mod_kinds.o
-init_pegrid.o: modules.o mod_kinds.o spectra_mod.o synthetic_turbulence_generator_mod.o
+init_pegrid.o: modules.o mod_kinds.o spectra_mod.o synthetic_turbulence_generator_mod.o \
+   vertical_nesting_mod.o
 init_pt_anomaly.o: modules.o mod_kinds.o
 init_rankine.o: modules.o mod_kinds.o
@@ -637,5 +627,5 @@
 surface_layer_fluxes_mod.o: modules.o mod_kinds.o exchange_horiz_2d.o land_surface_model_mod.o \
 	urban_surface_mod.o surface_mod.o
-surface_mod.o: modules.o mod_kinds.o init_pegrid.o model_1d_mod.o 
+surface_mod.o: modules.o mod_kinds.o model_1d_mod.o 
 swap_timelevel.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
    pmc_interface_mod.o urban_surface_mod.o
@@ -648,5 +638,5 @@
 	spectra_mod.o user_actions.o microphysics_mod.o synthetic_turbulence_generator_mod.o \
         surface_layer_fluxes_mod.o surface_mod.o \
-	urban_surface_mod.o virtual_flight_mod.o wind_turbine_model_mod.o
+	urban_surface_mod.o vertical_nesting_mod.o virtual_flight_mod.o wind_turbine_model_mod.o
 time_integration_spinup.o: cpulog_mod.o modules.o land_surface_model_mod.o mod_kinds.o radiation_model_mod.o surface_layer_fluxes_mod.o urban_surface_mod.o 
 time_to_string.o: mod_kinds.o
@@ -689,4 +679,5 @@
 user_spectra.o: modules.o mod_kinds.o spectra_mod.o user_module.o
 user_statistics.o: modules.o mod_kinds.o netcdf_interface_mod.o user_module.o
+vertical_nesting_mod.o: modules.o mod_kinds.o surface_mod.o 
 virtual_flight_mod.o: modules.o cpulog_mod.o mod_kinds.o netcdf_interface_mod.o user_init_flight.o user_flight.o
 wind_turbine_model_mod.o: modules.o cpulog_mod.o mod_kinds.o
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 2364)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 2365)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented: exclude setting vertical velocity to zero 
+! on fine grid (SadiqHuq)
+! 
+! 2320 2017-07-21 12:47:43Z suehring
 ! Remove unused control parameter large_scale_forcing from only-list
 ! 
@@ -166,5 +170,5 @@
     USE control_parameters,                                                    &
         ONLY:  bc_pt_t_val, bc_q_t_val, bc_s_t_val, constant_diffusion,        &
-               cloud_physics, dt_3d, humidity,                                 &
+               cloud_physics, coupling_mode, dt_3d, humidity,                  &
                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, ibc_s_t,         &
                ibc_sa_t, ibc_uv_b, ibc_uv_t, inflow_l, inflow_n, inflow_r,     &
@@ -237,6 +241,9 @@
     ENDIF
 
-    IF ( .NOT. nest_domain )  THEN
-       w_p(nzt:nzt+1,:,:) = 0.0_wp  ! nzt is not a prognostic level (but cf. pres)
+!
+!-- Vertical nesting: Vertical velocity not zero at the top of the fine grid
+    IF (  .NOT.  nest_domain  .AND.                                            &
+                 TRIM(coupling_mode) /= 'vnested_fine' )  THEN
+       w_p(nzt:nzt+1,:,:) = 0.0_wp  !< nzt is not a prognostic level (but cf. pres)
     ENDIF
 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 2364)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 2365)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented: Check coupling mode. Generate file header
+! (SadiqHuq)
+! 
+! 2354 2017-08-17 10:49:36Z schwenkel
 ! Bugfix correlated to lsm_check_data_output_pr.
 ! If-statement for following checks is essential, otherwise units for lsm output 
@@ -561,4 +565,6 @@
     USE wind_turbine_model_mod,                                                &
         ONLY:  wtm_check_parameters, wind_turbine
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested, vnest_check_parameters
 
 
@@ -603,4 +609,6 @@
 !> @todo Check if any queries for other coupling modes (e.g. precursor_ocean) are missing
     IF ( coupling_mode /= 'uncoupled'            .AND.  &
+         coupling_mode /= 'vnested_crse'         .AND.  &
+         coupling_mode /= 'vnested_fine'         .AND.  &
          coupling_mode /= 'atmosphere_to_ocean'  .AND.  &
          coupling_mode /= 'ocean_to_atmosphere' )  THEN
@@ -611,5 +619,6 @@
 !
 !-- Check dt_coupling, restart_time, dt_restart, end_time, dx, dy, nx and ny
-    IF ( coupling_mode /= 'uncoupled')  THEN
+    IF ( coupling_mode /= 'uncoupled'  .AND.                                   &
+         coupling_mode(1:8) /= 'vnested_' )  THEN
 
        IF ( dt_coupling == 9999999.9_wp )  THEN
@@ -809,4 +818,8 @@
     IF ( coupling_mode == 'uncoupled' )  THEN
        coupling_string = ''
+    ELSEIF ( coupling_mode == 'vnested_crse' )  THEN
+       coupling_string = ' nested (coarse)'
+    ELSEIF ( coupling_mode == 'vnested_fine' )  THEN
+       coupling_string = ' nested (fine)'
     ELSEIF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
        coupling_string = ' coupled (atmosphere)'
@@ -3858,4 +3871,7 @@
     ENDIF
 
+!-- Vertical nesting: check fine and coarse grid compatibility for data exchange
+    IF ( vnested )  CALL vnest_check_parameters
+
     CALL location_message( 'finished', .TRUE. )
 !
Index: palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- palm/trunk/SOURCE/diffusivities.f90	(revision 2364)
+++ palm/trunk/SOURCE/diffusivities.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented (SadiqHuq)
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -108,4 +111,7 @@
         ONLY :  bc_h
 
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_boundary_conds_khkm, vnest_init
+
     IMPLICIT NONE
 
@@ -266,4 +272,7 @@
        kh(:,nyn+1,:) = kh(:,nyn,:)
     ENDIF
+!
+!-- Vertical nesting: set fine grid eddy viscosity top boundary condition
+    IF ( vnest_init )  CALL vnest_boundary_conds_khkm
 
  END SUBROUTINE diffusivities
Index: palm/trunk/SOURCE/init_coupling.f90
===================================================================
--- palm/trunk/SOURCE/init_coupling.f90	(revision 2364)
+++ palm/trunk/SOURCE/init_coupling.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! ------------------
 ! $Id$
+! Vertical nesting implemented (SadiqHuq)
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! MPI2 coupling removed
 ! 
@@ -67,4 +70,6 @@
     USE pegrid
 
+    USE vertical_nesting_mod
+
     IMPLICIT NONE
 
@@ -96,4 +101,6 @@
        IF ( TRIM( coupling_mode ) == 'coupled_run' )  THEN
           i = 1
+       ELSEIF ( TRIM( coupling_mode ) == 'vnested_twi' )  THEN
+          i = 9
        ELSE
           i = 0
@@ -111,5 +118,5 @@
     i = bc_data(0)
 
-    IF ( i == 0 ) THEN
+    IF ( i == 0 )  THEN
        coupling_mode = 'uncoupled'
 !
@@ -121,4 +128,32 @@
           CLOSE ( 90 )
        ENDIF
+    ELSEIF ( i == 9 )  THEN
+
+!
+!--    Set a flag to identify runs with vertical nesting
+       vnested = .TRUE.
+       
+       comm_inter = MPI_COMM_WORLD
+       
+!
+!--    Split the total available PE's into two groups
+!--    numprocs for Coarse and Fine Grid are specified via mrun argument -N 
+       IF ( myid < bc_data(1) )  THEN
+          inter_color     = 0
+          numprocs        = bc_data(1)
+          coupling_mode   = 'vnested_crse'
+       ELSE
+          inter_color     = 1
+          numprocs        = bc_data(2)
+          coupling_mode   = 'vnested_fine'
+       ENDIF
+       
+       CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, inter_color, 0, comm_palm, ierr )
+       comm2d = comm_palm
+       
+       OPEN( 90, FILE='VNESTING_PORT_OPENED', FORM='FORMATTED' )
+       WRITE ( 90, '(''TRUE'')' )
+       CLOSE ( 90 )
+      
     ELSE
        comm_inter = MPI_COMM_WORLD
@@ -154,3 +189,9 @@
     ENDIF
 
+    IF (  TRIM( coupling_mode ) == 'vnested_fine' )  THEN
+!
+!-- Set file extension for vertical nesting
+       coupling_char = '_N'
+    ENDIF
+
  END SUBROUTINE init_coupling
